using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Reporting.WebForms;
using System.Collections.Generic;
using EjemploTableAdapters;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        ReportViewer1.LocalReport.DataSources.Add(new ReportDataSource("Ejemplo_Productos", GetData()));        
        ReportViewer1.DataBind();
    }
    private void RenderReport()
    {
        LocalReport localReport = new LocalReport();
        localReport.ReportPath = Server.MapPath("~/Productos.rdlc");

        ReportDataSource reportDataSource = new ReportDataSource("Ejemplo_Productos", GetData());
        localReport.DataSources.Add(reportDataSource);

        string reportType = "Image";
        string mimeType;
        string encoding;
        string fileNameExtension;
        
        //The DeviceInfo settings should be changed based on the reportType
        //http://msdn2.microsoft.com/en-us/library/ms155397.aspx
        string deviceInfo =
        "<DeviceInfo>" +
        "  <OutputFormat>PDF</OutputFormat>" +
        "  <PageWidth>8.5in</PageWidth>" +
        "  <PageHeight>11in</PageHeight>" +
        "  <MarginTop>0.5in</MarginTop>" +
        "  <MarginLeft>1in</MarginLeft>" +
        "  <MarginRight>1in</MarginRight>" +
        "  <MarginBottom>0.5in</MarginBottom>" +
        "</DeviceInfo>";

        Warning[] warnings;
        string[] streams;
        byte[] renderedBytes;
        
        //Render the report
        renderedBytes = localReport.Render(
            reportType,
            //deviceInfo,
            null,
            out mimeType,
            out encoding,
            out fileNameExtension,
            out streams,
            out warnings);
        
        Response.Clear();
        Response.ContentType = mimeType;
        Response.AddHeader("content-disposition", "attachment; filename=productos." + fileNameExtension);
        Response.BinaryWrite(renderedBytes);
        Response.End();
    }

    private Ejemplo.ProductosDataTable GetData()
    {
        ProductosTableAdapter adapter = new ProductosTableAdapter();
        Ejemplo.ProductosDataTable productos = new Ejemplo.ProductosDataTable();

        adapter.Fill(productos);

        return productos;
    }
    protected void cmdExportar_Click(object sender, EventArgs e)
    {
        RenderReport();
    }
}
